<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NoSuchReasonException StructType
 * @subpackage Structs
 */
class NoSuchReasonException extends Exception
{
    /**
     * The NoSuchReasonException
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NoSuchReasonException
     */
    public $NoSuchReasonException;
    /**
     * Constructor method for NoSuchReasonException
     * @uses NoSuchReasonException::setNoSuchReasonException()
     * @param \StructType\NoSuchReasonException $noSuchReasonException
     */
    public function __construct(\StructType\NoSuchReasonException $noSuchReasonException = null)
    {
        $this
            ->setNoSuchReasonException($noSuchReasonException);
    }
    /**
     * Get NoSuchReasonException value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NoSuchReasonException|null
     */
    public function getNoSuchReasonException()
    {
        return isset($this->NoSuchReasonException) ? $this->NoSuchReasonException : null;
    }
    /**
     * Set NoSuchReasonException value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\NoSuchReasonException $noSuchReasonException
     * @return \StructType\NoSuchReasonException
     */
    public function setNoSuchReasonException(\StructType\NoSuchReasonException $noSuchReasonException = null)
    {
        if (is_null($noSuchReasonException) || (is_array($noSuchReasonException) && empty($noSuchReasonException))) {
            unset($this->NoSuchReasonException);
        } else {
            $this->NoSuchReasonException = $noSuchReasonException;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NoSuchReasonException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
